var a = angular.module("speciesconratesApp", [], function($interpolateProvider) {
            $interpolateProvider.startSymbol('[[');
            $interpolateProvider.endSymbol(']]');
        }
    );



var myfactory = a.factory('myfactory', function($http, $q) {

    return {
        getData : function() {




            var deferred = $q.defer();

            $http.get('speciesconrates.json').success(function(data) {
                console.log('in speciesconrates factory, success loading data.');
                deferred.resolve(data);
            }).error(function(){
                console.log('Error loading species reaction rate data from file speciesconrates.json');
                deferred.reject();
            });

            return deferred.promise;




        }

    }
});

function speciesconratesController($scope,myfactory) {
    $scope.initialize = function() {
        var data = myfactory.getData().then(
                function(data) { 


                    // Scale the reaction rate by taking the log.
                    // This really ought to be done in post-processing. 
                    //
                    // Ignore species < 1e-12 mole frac.
                    var low_threshold = -12; 

                    var rate = 0;
                    var log_rate = 0;
                    var scaled_rate = 0;
                    data.forEach( function(p) {
                        rate = p.rev_rxn_rate;
                        log_rate = Math.log(rate);

                        // scaled rate:
                        // 0 = 1e-12 or smaller mole frac
                        // no maxmium
                        scaled_rate = d3.max([-12,log_rate]) - low_threshold;

                        p.scaled_rev_rxn_rate = scaled_rate;

                    });

                    $scope.myData = data;
                });
    }
}

// the first few arguments of the list should correspond to the Angular-namespace stuff to feed to HelloController
var c = a.controller("speciesconratesController", ["$scope", "myfactory", speciesconratesController]);

