var ng;
dir = [];


//////////////////////////////////////
//
// Species Generation Rates Rank Directives
//
// <speciesgenrates-head>
// <speciesgenrates-chart>
//
//////////////////////////////////////





//////////////////////////////////////
// Species Generation Rates Rank Chart
// Header 
//

ng = a.directive('speciesgenratesHead', function($compile) {

    function link(scope, element, attr) {

        var el = $("div#head");

        $(el).empty();

        var h1 = $("<h1 />")
            .appendTo(el);

        var b = $("<b />")
            .text("Species Generation Rate Rank Chart")
            .appendTo(h1);

    }
    return {
        restrict: "E",
        link: link,
        scope: {}
    }
});
dir.push(ng);




//////////////////////////////////////
// Species Generation Rates Rank Chart
// Chart
//


ng = a.directive('speciesgenratesChart', function($compile) {

    function link(scope, element, attr) {

        scope.$parent.$watch('myData',doStuff);

        function doStuff() { 
            if(!scope.$parent.myData) { return }
            updateChart(element, scope.$parent.myData);
        }

    };

    function updateChart(element,data) { 


        var el = element[0];


        ///////////////////////////////////
        // now draw the bar chart with d3 
        // 
        // https://www.dashingd3js.com/lessons/basic-chart-grouped-bar-chart
        //

        var margin = {top: 20, right: 20, bottom: 30, left: 40},
            width = 800 - margin.left - margin.right,
            height = 300 - margin.top - margin.bottom;
        
        var x = d3.scale.ordinal()
            .rangeRoundBands([0, width], .1);
        
        var y = d3.scale.linear()
            .range([height, 0]);

        var xAxis = d3.svg.axis()
            .scale(x)
            .orient("bottom");
        
        // need to re-scale the labels here, N + 12 then 10^{N+12}
        var yAxis = d3.svg.axis()
            .scale(y)
            .orient("left")
            .ticks(10);
        
        var svg = d3.select(el).append("svg")
            .attr("width", width + margin.left + margin.right)
            .attr("height", height + margin.top + margin.bottom)
          .append("g")
            .attr("transform", "translate(" + margin.left + "," + margin.top + ")");
        
        y.domain([0, d3.max(data, function(d) { 
            if( d.scaled_fwd_rxn_rate >= 1 ) {
                return d.scaled_fwd_rxn_rate;
            }
        })]);




        // // filter out species with mole frac < 1e-10 (-10, offset by -12, is 2)
        // // (variable number of species)
        // var xdom_data = data.filter( function(d) {
        //      if( d.scaled_fwd_rxn_rate >= 0.2 ) {
        //          return d;
        //      }
        // }).sort( function(a,b) {
        //     if(a.scaled_fwd_rxn_rate > b.scaled_fwd_rxn_rate) { return -1 }
        //     if(a.scaled_fwd_rxn_rate < b.scaled_fwd_rxn_rate) { return 1 }
        //     return 0
        // });
        // x.domain( xdom_data.map(function(d) { return d.species; }) );




        // show N species
        var Nsp = 15;
        var xdom_data = data.sort( function(a,b) {
                if(a.scaled_fwd_rxn_rate > b.scaled_fwd_rxn_rate) { return -1 }
                if(a.scaled_fwd_rxn_rate < b.scaled_fwd_rxn_rate) { return 1 }
                return 0
            }).filter( function(d,i) {
                if(i <= Nsp ) {
                    return d;
                }
            });
        x.domain( xdom_data.map(function(d) { return d.species; }) );




        svg.append("g")
            .attr("class", "x axis")
            .attr("transform", "translate(0," + height + ")")
            .call(xAxis);
        
        svg.append("g")
            .attr("class", "y axis")
            .call(yAxis)
          .append("text")
            .attr("transform", "rotate(-90)")
            .attr("dy", "-3.0em") // horizontal placement
            .attr("dx", "-10.0em") // vertical placement
            .style("text-anchor", "end")
            .text("Reaction Rate [mol/s]");
        
        svg.selectAll(".bar")
            .data(xdom_data)
          .enter().append("rect")
            .attr("class", "bar")
            .attr("x", function(d) { return x(d.species); })
            .attr("width", x.rangeBand())
            .attr("y", function(d) { return y(d.scaled_fwd_rxn_rate); })
            .attr("height", function(d) { return height - y(d.scaled_fwd_rxn_rate); });
        

        function type(d) {
          d.scaled_fwd_rxn_rate = +d.scaled_fwd_rxn_rate;
          return d;
        }

    };

    return {
        link: link,
        restrict: "E",
        scope: {}
    };

});
dir.push(ng);


